local AddonName, AddonTable = ...

local Addon = LibStub("AceAddon-3.0"):NewAddon(AddonName)
AddonTable.Addon = Addon
Addon:SetDefaultModuleState(false)

LibStub("AceEvent-3.0"):Embed(AddonTable)

local db = {}
AddonTable.db = db

db.activewhen = {
  -- ["solo"] = false,
  ["party"] = true,
  ["raid"] = true,
  ["instance_arena"] = true,
  ["instance_party"] = true,
  ["instance_raid"] = true,
  ["instance_pvp"] = true,
}

local groupType

local function CheckStatus()
  local oldType = groupType

  local inInstance, instanceType = IsInInstance()
  if inInstance then
    groupType = "instance_"..instanceType
  elseif GetNumRaidMembers() > 0 then
    groupType = "raid"
  elseif GetNumPartyMembers() > 0 then
    groupType = "party"
  else
    groupType = "solo"
  end

  if oldType ~= groupType then
    local action = db.activewhen[groupType] and "Enable" or "Disable"
    for name, module in Addon:IterateModules() do
      module[action](module)
    end
  end
end

function Addon:OnInitialize()
  AddonTable:RegisterEvent("PLAYER_ENTERING_WORLD", CheckStatus)
  AddonTable:RegisterEvent("PARTY_MEMBERS_CHANGED", CheckStatus)
  AddonTable:RegisterEvent("RAID_ROSTER_UPDATE", CheckStatus)

  CheckStatus()
end

function Addon:OnEnable()
  self:SetEnabledState(false) -- Forbid enabling
end
