local AddonName, AddonTable = ...

local Addon = AddonTable.Addon
local Module = Addon:NewModule("Console")

local AC = LibStub("AceConsole-3.0")

local function BuffAdded(_, unit)
  AC:Print(format("%s -> %s", unit:GetOwner().name, unit.name))
end

local function BuffRemoved(_, unit)
  AC:Print(format("[[ %s ]]", unit.name))
end

function Module:OnEnable()
  Addon.RegisterCallback(self, "AURA_GAINED", BuffAdded)
  Addon.RegisterCallback(self, "AURA_LOST", BuffRemoved)
end

function Module:OnDisable()
  Addon.UnregisterAllCallbacks(self)
end
